#!/bin/sh
#fdisk /dev/mmc/disc0/disc
SD=/dev/mmc/disc0/disc
MD=/lib/modules/$(uname -r)
IM=/sbin/insmod
POP_CONF="/var/tuxbox/config/popup.conf"
SIZE=$(grep ^SIZE=.* $POP_CONF | cut -d '=' -f 2)
TIME_POPUP=30

out="/dev/null"
if grep -q 'ttyS0' /var/tuxbox/boot/boot.conf; then
	out="/dev/console"
fi

msg=/tmp/inst.txt
msg1=/tmp/inst1.txt

FLS=EXT2
if lsmod | grep ext3 > /dev/null && [ -e /var/etc/.mmc_ext3 ]; then
	FLS=EXT3
fi

wait_msgbox ()
{
	while [ 1 ]
	do
	if pidof msgbox > /dev/null; then
	xsleep 500000
	killall msgbox
	break
	fi
	xsleep 500000
	done
}

MSGBOX2 ()
{
echo ~cBitte warten >> $msg1
msgbox refresh=0 size=32 timeout=90 title="none" popup=$msg1
rm $msg1
}

mounttest ()
{
if mount | grep 'mmc/disc0' > /dev/null; then
	/etc/init.d/endprog mmc
	umount /mmc
	xsleep 500000
	if mount | grep 'mmc/disc0' > /dev/null; then
		echo ~c~FVorgang wurde abgebrochen ! > $msg
		echo ~c~YSD/MMC-Karte ~Skonnte nicht unmountet werden. >> $msg
		echo ~s >> $msg
		echo ~cBitte alle auf Karte laufende Prozesse beenden. >> $msg
		if [ -e /var/etc/.neutrino_mmc -o -e /var/etc/.neutrino_ide ] ; then
			echo ~s >> $msg
			echo ~cDie ~Yausgelagerte Neutrino ~Smu~z in das Image >> $msg
			echo ~czur~uckgespielt werden. >> $msg
		fi
		echo ~s >> $msg
		echo ~cDanach erneut versuchen. >> $msg
		/bin/msgbox title="MMC/SD Utilitys" refresh=1 cyclic=0 order=1 absolute=1 default=1 size=32 msg="$msg" select="Vorgang abbrechen,Alle Prozesse beenden und Karte erneut unmounten." timeout=300
		case "$?" in
			1)
				echo ~cNeue Auswahl oder Men~u mit Home verlassen ? > $msg
				xsleep 500000
				[ -e $msg1 ] && rm $msg1
				$0 MSGBOX
				exit
			;;
			2)
				if [ -e /var/etc/.neutrino_mmc -o -e /var/etc/.neutrino_ide ] ; then
					echo ~c~FAchtung: ~SVorgang abgebrochen. > $msg
					echo ~s >> $msg
					echo ~cAusgelagerte ~YNeutrino ~Smu~z erst in >> $msg
					echo ~cdas Image zur~uckgespielt werden. >> $msg
					echo ~s >> $msg
					$0 MSGBOX
					exit
				fi
				touch /tmp/.install_mmc
				touch /tmp/.msg2
				killall shellexec
				killall msgbox
				wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
				touch /tmp/.mmc_fuser
				exit
			;;
			*)
				echo ~cNeue Auswahl oder Men~u mit Home verlassen ? > $msg
				xsleep 500000
				[ -e $msg1 ] && rm $msg1
				$0 MSGBOX
				exit
			;;
			esac
	fi
fi
}

part_sd ()
{
echo ~cMMC/SD-Karte wird partitioniert. > $msg1
echo ~c~YAlle Daten werden gel~oscht >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX2
mounttest
if [ ! -e /tmp/.msg2 ];then
echo "Create the partition label"
sfdisk -f $SD << EOF
;
;
;
;
EOF

echo ~cVorgang ~Y-- Partitioniern -- ~Sist abgeschlossen ! > $msg1
echo ~s >> $msg1
echo ~cMMC/SD wird mit ~Y$FLS ~Sformatiert. >> $msg1
echo ~s >> $msg1
echo ~c~YDauer des Vorgangs bei einer 512MB Karte >> $msg1
echo ~c~Yca. ~S1-2 ~YMinuten >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX2
if lsmod | grep ext3 > /dev/null && [ -e /var/etc/.mmc_ext3 ]; then
	mkfs.ext3 /dev/mmc/disc0/part1
else
	mkfs.ext2 /dev/mmc/disc0/part1
fi
sleep 2
mount /dev/mmc/disc0/part1 /mmc
sleep 1
fi

}

part_sdswap ()
{
echo ~cMMC/SD-Karte wird partitioniert. > $msg1
echo ~c~YGleichzeitig wird eine ~G64MB ~Sgroe ~GSWAP-Partition ~Yangelegt. >> $msg1
echo ~c~YAlle Daten werden gel~oscht >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX2
mounttest
if [ ! -e /tmp/.msg2 ];then
echo "Create the partition label"
sfdisk -uM -f $SD << EOF
0,64,S
;
;
;
EOF

mkswap /dev/mmc/disc0/part1
sleep 1
echo ~cVorgang ~Y-- Partitioniern -- ~Sist abgeschlossen ! > $msg1
echo ~s >> $msg1
echo ~cMMC/SD wird mit ~Y$FLS ~Sformatiert. >> $msg1
echo ~s >> $msg1
echo ~c~YDauer des Vorgangs bei einer 512MB Karte >> $msg1
echo ~c~Yca. ~S1-2 ~YMinuten >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX2
if lsmod | grep ext3 > /dev/null && [ -e /var/etc/.mmc_ext3 ]; then
	mkfs.ext3 /dev/mmc/disc0/part2
else
	mkfs.ext2 /dev/mmc/disc0/part2
fi
sleep 2
mount /dev/mmc/disc0/part2 /mmc
sleep 1
fi
}

test_part ()
{
fdisk $SD << EOF
p
EOF

}

case "$1" in

MSGBOX)
/bin/msgbox title="MMC/SD Utilitys" refresh=1 order=2 absolute=1 default=3 size=32 msg="$msg" select="MMC/SD mit EXT2 formatieren,MMC/SD mit EXT3 formatieren,MOUNT-Test,MMC/RAM Speicherauslastung,MMC/SD ohne Swap partitionieren,MMC/SD mit Swap partitionieren,Check MMC/SD Karte,DBOX Reboot" timeout=300
case "$?" in
	1)
		echo ~cMMC/SD wird mit EXT2 formatiert > $msg1
		echo ~cAlle Daten werden gel~oscht >> $msg1
		echo ~s >> $msg1
		echo ~c~YDauer des Vorgangs bei einer 512MB Karte >> $msg1
		echo ~c~Yca. ~S1-2 ~YMinuten >> $msg1
		echo ~s >> $msg1
		wait_msgbox &
		MSGBOX2
		mounttest
		if [ ! -e /tmp/.msg2 ];then
		if (lsmod | grep ext3 > /dev/null || [ -e /var/etc/.mmc_ext3 ]) && [ ! -e /var/etc/.ide_ext3 -o ! -e /var/etc/.start_ide ] ; then rmmod ext3; rmmod jbd; fi
		[ ! -e /var/etc/.mmc_ext2 ] && touch /var/etc/.mmc_ext2
		[ -e /var/etc/.mmc_ext3 ] && rm /var/etc/.mmc_ext3
		if ! lsmod | grep ext2 > /dev/null ; then $IM ext2; fi
		xsleep 500000
		echo "Formatiere MMC Karte mit EXT2" > $out
		if test_part | grep '82  Linux swap' > /dev/null; then
			mkswap /dev/mmc/disc0/part1
			sleep 2
			mkfs.ext2 /dev/mmc/disc0/part2
			sleep 2
			mount /dev/mmc/disc0/part2 /mmc
		else
			mkfs.ext2 /dev/mmc/disc0/part1
			sleep 2
			mount /dev/mmc/disc0/part1 /mmc
		fi
		sleep 1
		if mount | grep 'mmc/disc0' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~cMMC/SD wurde mit EXT2 formatiert > $msg
			echo ~c~s >> $msg
			echo ~c~YMMC/SD ~Sist nach ~Y/mmc ~Sgemountet >> $msg
		else
			echo ~cFEHLER !! > $msg
			echo ~cMMC/SD wurde nicht richtig formatiert >> $msg
			if ! lsmod | grep ext2 > /dev/null ; then
				echo ~cTreiber ~YEXT2 ~Sist nicht geladen. >> $msg
			fi
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ! >> $msg
		fi
		killall msgbox
		$0 MSGBOX
		fi
		;;
	2)
		echo ~cMMC/SD wird mit EXT3 formatiert > $msg1
		echo ~cAlle Daten werden gel~oscht >> $msg1
		echo ~s >> $msg1
		echo ~c~YDauer des Vorgangs bei einer 512MB Karte >> $msg1
		echo ~c~Yca. ~S1-2 ~YMinuten >> $msg1
		echo ~s >> $msg1
		wait_msgbox &
		MSGBOX2
		mounttest
		if [ ! -e /tmp/.msg2 ];then
		if (lsmod | grep ext2 > /dev/null || [ -e /var/etc/.mmc_ext2 ]) && [ -e /var/etc/.noide_ext2 -o ! -e /var/etc/.start_ide ] ; then rmmod ext2; fi
		[ -e /var/etc/.mmc_ext2 ] && rm /var/etc/.mmc_ext2
		[ ! -e /var/etc/.mmc_ext3 ] && touch /var/etc/.mmc_ext3
		if ! lsmod | grep jbd > /dev/null ; then $IM jbd; fi
		if ! lsmod | grep ext3 > /dev/null ; then $IM ext3; fi
		xsleep 500000
		echo "Formatiere MMC Karte mit EXT3" > $out
		if test_part | grep '82  Linux swap' > /dev/null; then
			mkswap /dev/mmc/disc0/part1
			sleep 2
			mkfs.ext3 /dev/mmc/disc0/part2
			sleep 2
			mount /dev/mmc/disc0/part2 /mmc
		else
			mkfs.ext3 /dev/mmc/disc0/part1
			sleep 2
			mount /dev/mmc/disc0/part1 /mmc
		fi
		sleep 1
		if mount | grep 'mmc/disc0' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~cMMC/SD wurde mit EXT3 formatiert > $msg
			echo ~c~s >> $msg
			echo ~c~YMMC/SD ~Sist nach ~Y/mmc ~Sgemountet >> $msg
		else
			echo ~cFEHLER !! > $msg
			echo ~cMMC/SD wurde nicht richtig formatiert >> $msg
			if ! lsmod | grep ext3 > /dev/null ; then
				echo ~cTreiber ~YEXT3 ~Sist nicht geladen. >> $msg
			fi
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ! >> $msg
		fi
		killall msgbox
		$0 MSGBOX
		fi
		;;
	3)
		if mount | grep 'mmc/disc0' > /dev/null; then
			echo ~cMMC/SD ist gemountet. > $msg
			$0 MSGBOX
		else
			echo ~cMMC/SD Karte ist ~Ynicht ~Sgemountet. > $msg
			/bin/msgbox title="MMC/SD Utilitys" refresh=1 cyclic=0 order=1 absolute=1 default=1 size=32 msg="$msg" select="MMC/SD nicht mounten,MMC/SD mounten" timeout=300
			case "$?" in
			1)
				$0 MSGBOX
			;;
			2)
				if test_part | grep '82  Linux swap' > /dev/null; then
					part="part2"
				else
					part="part1"
				fi
				mount /dev/mmc/disc0/$part /mmc
				sleep 1
				if mount | grep 'mmc/disc0' > /dev/null; then
					echo ~cMMC/SD ist gemountet. > $msg
					echo ~s >> $msg
					echo ~c~YMen~u: ~SMMC/SD Utilitys >> $msg
					echo ~cmu~z bei Bedarf neu aufgerufen werden. >> $msg
					/bin/msgbox title="MMC/SD Utilitys" refresh=1 cyclic=0 size=32 msg="$msg" timeout=300
					rm $msg
					killall shellexec
					sectionsdcontrol --nopause
					exit
				else
					echo ~cMMC/SD kann nicht gemountet werden. > $msg
					echo ~s~c >> $msg
					echo ~cMMC/SD Karte richtig eingebaut und formatiert ? >> $msg
					echo ~cMMC/SD Treiber richtig geladen ? >> $msg
					$0 MSGBOX
				fi
			;;
			*)
				$0 MSGBOX
			;;
			esac	
		fi
		;;
	4)
		Flexmenu="/var/plugins/shellexec"
		menu=/tmp/.speicher
		param () {
		echo FONT=/share/fonts/micron_bold.ttf > $menu
		echo KILLEPG=2 >> $menu
		echo TIMESERVICE=NONE >> $menu
		echo HIGHT=420 >> $menu
		echo WIDTH=520 >> $menu
		echo FONTSIZE=20 >> $menu
		echo PAGING=1 >> $menu
		echo LINESPP=12 >> $menu
		echo MENU=HDD-MMC-RAM Speicherauslastung >> $menu
		cat /var/tuxbox/config/glj_conf/speicher.conf >> $menu
		echo ENDMENU >> $menu
	       }
	       param
	       $Flexmenu "$menu"
	       rm $menu
	       $0 MSGBOX
	;;
	5)
		part_sd
		if [ ! -e /tmp/.msg2 ];then
		sleep 2
		if (test_part | grep '83  Linux' && mount | grep 'mmc/disc0') > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~c~YSD/MMC-Karte ~Swurde erfolgreich partitioniert und > $msg
			echo ~cmit dem Filesystem ~Y$FLS ~Sformatiert. >> $msg
			echo ~cDie ~YSD/MMC-Karte ~Skann jederzeit umformatiert werden. >> $msg
			echo ~c~s >> $msg
			echo ~c~YMMC/SD ~Sist nach ~Y/mmc ~Sgemountet >> $msg
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cSD/MMC-Karte ~Ywurde ~Snicht richtig ~Ypartitioniert ~Sund ~Yformatiert. >> $msg
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		[ -e /tmp/partition ] && rm /tmp/partition
		killall msgbox
		$0 MSGBOX
		fi
		;;
	6)
		part_sdswap
		if [ ! -e /tmp/.msg2 ];then
		sleep 2
		if (test_part | grep '82  Linux swap' && test_part | grep '83  Linux' && mount | grep 'mmc/disc0') > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~c~YMMC/SD-Karte ~Swurde erfolgreich partitioniert. > $msg
			echo ~c~G64MB Swap-Partition ~Swurde angelegt. >> $msg
			echo ~s >> $msg
			echo ~c~YDie SWAP-Funktion ~Skann im MMC-Men~u bei Bedarf aktiviert >> $msg
			echo ~cbzw. deaktiviert werden. DBOX ~YNeustart ~Serforderlich ! >> $msg
			echo ~s >> $msg
			echo ~c~YMMC/SD-Karte ~Swurde mit dem Filsystem ~Y$FLS ~Sformatiert >> $msg
			echo ~cund kann jederzeit umformatiert werden. >> $msg
			echo ~c~s >> $msg
			echo ~c~YMMC/SD ~Sist nach ~Y/mmc ~Sgemountet >> $msg
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cSD/MMC-Karte ~Ywurde ~Snicht richtig ~Ypartitioniert ~Sund ~Yformatiert. >> $msg
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		[ -e /tmp/partition ] && rm /tmp/partition
		killall msgbox
		$0 MSGBOX
		fi
		;;
	7)
		if [ -e /var/etc/.neutrino_mmc -o -e /var/etc/.neutrino_ide ] ; then
			echo ~c~FAchtung: ~SVorgang abgebrochen. > $msg
			echo ~s >> $msg
			echo ~cAusgelagerte ~YNeutrino ~Smu~z erst in >> $msg
			echo ~cdas Image zur~uckgespielt werden. >> $msg
			echo ~s >> $msg
			echo ~cDanach kann ~YCheck MMC/SD ~Swiederholt werden. >> $msg
			$0 MSGBOX
			exit
		fi
		touch /tmp/.check_mmc
		killall shellexec
		killall msgbox
		touch /tmp/.msg2
		wget -O /dev/null http://localhost/cgi-bin/startPlugin?name=msgbox.cfg >$out
		/etc/init.d/endprog mmc
		if mount | grep 'mmc/disc0' > /dev/null; then
			touch /tmp/.mmc_fuser
		else
			/sbin/ide_mmc.sh mmc &
			killall mmc_utility.sh
		fi
		;;
	8)
		if [ ! -e /tmp/.mmc_fuser ];then
			touch /tmp/.reboot
			if [ -e /etc/init.d/end_neutrino ] ; then
				/etc/init.d/end_neutrino
			else
				/var/plugins/emuoptions
			fi
		fi
	;;
	*)
		[ -e $msg ] && rm $msg
		[ -e $msg1 ] && rm $msg1
		exit
		;;
		esac
;;
START)
	if [ -e /var/etc/.mmc_on ] ; then
		if lsmod | grep vfat > /dev/null; then
			/bin/msgbox msg="~cTreiber ~YVFAT ~Sist geladen~n~s~n~cFormatieren nicht m~oglich.~n~cBei ausgew~ahltem ~YVFAT-Treiber ~Sk~onnen nur~n~c~YVFAT ~Svorformatierte SD/MMC Karten verwendet werden !" title="none" timeout=30 size=36
			exit
		fi
		if ! lsmod | grep mmc* > /dev/null || ! lsmod | grep ext* > /dev/null; then
		#if ! lsmod | grep mmc* > /dev/null; then
			/bin/msgbox msg="~YMMC-Treiber konnte nicht geladen werden.~n~cBitte Treiber aktivieren.~n~cGegebenenfalls DBOX neu starten.~n~cDanach Men~u ~YMMC/SD Utilitys ~Sneu aufrufen !~n~s~n~c~YEventuell sind keine Treiber $MD~n~c~Yinstalliert." timeout=$TIME_POPUP size=$SIZE
			exit
		else
	
			echo ~cBei der ersten Inbetriebnahme muss die MMC/SD Karte > $msg
			echo ~cpartitioniert und formatiert werden. >> $msg
			echo ~c~YBeim Partitionieren kann ausgw~ahlt werden ob zus~atzlich eine >> $msg
			echo ~c~SSWAP-Partition ~Yangelegt werden soll. Die ~SSWAP-Funktion ~Ybei >> $msg
			echo ~c~YSD/MMC-Karten sollten nur die experimentierfreudigen user testen. >> $msg
			echo ~cSWAP kann zu jeder Zeit wieder deaktiviert werden. >> $msg
			echo ~s  >> $msg
			echo ~cEine bereits partitionierte bzw. formatierte MMC/SD Karte >> $msg
			echo ~ckann nachtr~aglich umpartitioniert bzw. umformatiert werden.  >> $msg
			echo ~c~YBereits auf der Karte befindliche Daten werden dabei gel~oscht. >> $msg
	
			$0 MSGBOX
		fi
	else
		/bin/msgbox msg="Keine ~YMMC/SD Treiber ~Saktiviert und geladen!~n~cBitte MMC/SD Treiber im Men~u aktivieren~n~cund ~YMen~u MMC/SD ~SUtilitys neu aufrufen !" timeout=$TIME_POPUP size=$SIZE
		killall msgbox
	fi
;;

esac
